// **********************************************************************
//
// Copyright (c) 2003-2008 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.0
// Generated from file `Hello.ice'

#if __MonoCS__

using _System = System;
using _Microsoft = Microsoft;
#else

using _System = global::System;
using _Microsoft = global::Microsoft;
#endif

namespace Demo
{
    public interface Hello : Ice.Object, HelloOperations_, HelloOperationsNC_
    {
    }
}

namespace Demo
{
    public interface HelloPrx : Ice.ObjectPrx
    {
        void sayHello(int delay);
        void sayHello(int delay, _System.Collections.Generic.Dictionary<string, string> context__);

        bool sayHello_async(Demo.AMI_Hello_sayHello cb__, int delay);
        bool sayHello_async(Demo.AMI_Hello_sayHello cb__, int delay, _System.Collections.Generic.Dictionary<string, string> ctx__);

        void shutdown();
        void shutdown(_System.Collections.Generic.Dictionary<string, string> context__);

        bool shutdown_async(Demo.AMI_Hello_shutdown cb__);
        bool shutdown_async(Demo.AMI_Hello_shutdown cb__, _System.Collections.Generic.Dictionary<string, string> ctx__);
    }
}

namespace Demo
{
    public interface HelloOperations_
    {
        void sayHello(int delay, Ice.Current current__);

        void shutdown(Ice.Current current__);
    }

    public interface HelloOperationsNC_
    {
        void sayHello(int delay);

        void shutdown();
    }
}

namespace Demo
{
    public sealed class HelloPrxHelper : Ice.ObjectPrxHelperBase, HelloPrx
    {
        #region Synchronous operations

        public void sayHello(int delay)
        {
            sayHello(delay, null, false);
        }

        public void sayHello(int delay, _System.Collections.Generic.Dictionary<string, string> context__)
        {
            sayHello(delay, context__, true);
        }

        private void sayHello(int delay, _System.Collections.Generic.Dictionary<string, string> context__, bool explicitContext__)
        {
            if(explicitContext__ && context__ == null)
            {
                context__ = emptyContext_;
            }
            int cnt__ = 0;
            while(true)
            {
                Ice.ObjectDel_ delBase__ = null;
                try
                {
                    delBase__ = getDelegate__(false);
                    HelloDel_ del__ = (HelloDel_)delBase__;
                    del__.sayHello(delay, context__);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper ex__)
                {
                    handleExceptionWrapper__(delBase__, ex__, null);
                }
                catch(Ice.LocalException ex__)
                {
                    handleException__(delBase__, ex__, null, ref cnt__);
                }
            }
        }

        public void shutdown()
        {
            shutdown(null, false);
        }

        public void shutdown(_System.Collections.Generic.Dictionary<string, string> context__)
        {
            shutdown(context__, true);
        }

        private void shutdown(_System.Collections.Generic.Dictionary<string, string> context__, bool explicitContext__)
        {
            if(explicitContext__ && context__ == null)
            {
                context__ = emptyContext_;
            }
            int cnt__ = 0;
            while(true)
            {
                Ice.ObjectDel_ delBase__ = null;
                try
                {
                    delBase__ = getDelegate__(false);
                    HelloDel_ del__ = (HelloDel_)delBase__;
                    del__.shutdown(context__);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper ex__)
                {
                    handleExceptionWrapper__(delBase__, ex__, null);
                }
                catch(Ice.LocalException ex__)
                {
                    handleException__(delBase__, ex__, null, ref cnt__);
                }
            }
        }

        #endregion

        #region Asynchronous operations

        public bool sayHello_async(Demo.AMI_Hello_sayHello cb__, int delay)
        {
            return sayHello_async(cb__, delay, null, false);
        }

        public bool sayHello_async(Demo.AMI_Hello_sayHello cb__, int delay, _System.Collections.Generic.Dictionary<string, string> ctx__)
        {
            return sayHello_async(cb__, delay, ctx__, true);
        }

        public bool sayHello_async(Demo.AMI_Hello_sayHello cb__, int delay, _System.Collections.Generic.Dictionary<string, string> ctx__, bool explicitContext__)
        {
            if(explicitContext__ && ctx__ == null)
            {
                ctx__ = emptyContext_;
            }
            return cb__.invoke__(this, cb__, delay, ctx__);
        }

        public bool shutdown_async(Demo.AMI_Hello_shutdown cb__)
        {
            return shutdown_async(cb__, null, false);
        }

        public bool shutdown_async(Demo.AMI_Hello_shutdown cb__, _System.Collections.Generic.Dictionary<string, string> ctx__)
        {
            return shutdown_async(cb__, ctx__, true);
        }

        public bool shutdown_async(Demo.AMI_Hello_shutdown cb__, _System.Collections.Generic.Dictionary<string, string> ctx__, bool explicitContext__)
        {
            if(explicitContext__ && ctx__ == null)
            {
                ctx__ = emptyContext_;
            }
            return cb__.invoke__(this, cb__, ctx__);
        }

        #endregion

        #region Checked and unchecked cast operations

        public static HelloPrx checkedCast(Ice.ObjectPrx b)
        {
            if(b == null)
            {
                return null;
            }
            HelloPrx r = b as HelloPrx;
            if((r == null) && b.ice_isA("::Demo::Hello"))
            {
                HelloPrxHelper h = new HelloPrxHelper();
                h.copyFrom__(b);
                r = h;
            }
            return r;
        }

        public static HelloPrx checkedCast(Ice.ObjectPrx b, _System.Collections.Generic.Dictionary<string, string> ctx)
        {
            if(b == null)
            {
                return null;
            }
            HelloPrx r = b as HelloPrx;
            if((r == null) && b.ice_isA("::Demo::Hello", ctx))
            {
                HelloPrxHelper h = new HelloPrxHelper();
                h.copyFrom__(b);
                r = h;
            }
            return r;
        }

        public static HelloPrx checkedCast(Ice.ObjectPrx b, string f)
        {
            if(b == null)
            {
                return null;
            }
            Ice.ObjectPrx bb = b.ice_facet(f);
            try
            {
                if(bb.ice_isA("::Demo::Hello"))
                {
                    HelloPrxHelper h = new HelloPrxHelper();
                    h.copyFrom__(bb);
                    return h;
                }
            }
            catch(Ice.FacetNotExistException)
            {
            }
            return null;
        }

        public static HelloPrx checkedCast(Ice.ObjectPrx b, string f, _System.Collections.Generic.Dictionary<string, string> ctx)
        {
            if(b == null)
            {
                return null;
            }
            Ice.ObjectPrx bb = b.ice_facet(f);
            try
            {
                if(bb.ice_isA("::Demo::Hello", ctx))
                {
                    HelloPrxHelper h = new HelloPrxHelper();
                    h.copyFrom__(bb);
                    return h;
                }
            }
            catch(Ice.FacetNotExistException)
            {
            }
            return null;
        }

        public static HelloPrx uncheckedCast(Ice.ObjectPrx b)
        {
            if(b == null)
            {
                return null;
            }
            HelloPrx r = b as HelloPrx;
            if(r == null)
            {
                HelloPrxHelper h = new HelloPrxHelper();
                h.copyFrom__(b);
                r = h;
            }
            return r;
        }

        public static HelloPrx uncheckedCast(Ice.ObjectPrx b, string f)
        {
            if(b == null)
            {
                return null;
            }
            Ice.ObjectPrx bb = b.ice_facet(f);
            HelloPrxHelper h = new HelloPrxHelper();
            h.copyFrom__(bb);
            return h;
        }

        #endregion

        #region Marshaling support

        protected override Ice.ObjectDelM_ createDelegateM__()
        {
            return new HelloDelM_();
        }

        protected override Ice.ObjectDelD_ createDelegateD__()
        {
            return new HelloDelD_();
        }

        public static void write__(IceInternal.BasicStream os__, HelloPrx v__)
        {
            os__.writeProxy(v__);
        }

        public static HelloPrx read__(IceInternal.BasicStream is__)
        {
            Ice.ObjectPrx proxy = is__.readProxy();
            if(proxy != null)
            {
                HelloPrxHelper result = new HelloPrxHelper();
                result.copyFrom__(proxy);
                return result;
            }
            return null;
        }

        #endregion
    }
}

namespace Demo
{
    public interface HelloDel_ : Ice.ObjectDel_
    {
        void sayHello(int delay, _System.Collections.Generic.Dictionary<string, string> context__);

        void shutdown(_System.Collections.Generic.Dictionary<string, string> context__);
    }
}

namespace Demo
{
    public sealed class HelloDelM_ : Ice.ObjectDelM_, HelloDel_
    {
        public void sayHello(int delay, _System.Collections.Generic.Dictionary<string, string> context__)
        {
            IceInternal.Outgoing og__ = handler__.getOutgoing("sayHello", Ice.OperationMode.Normal, context__);
            try
            {
                try
                {
                    IceInternal.BasicStream os__ = og__.ostr();
                    os__.writeInt(delay);
                }
                catch(Ice.LocalException ex__)
                {
                    og__.abort(ex__);
                }
                bool ok__ = og__.invoke();
                if(!og__.istr().isEmpty())
                {
                    try
                    {
                        if(!ok__)
                        {
                            try
                            {
                                og__.throwUserException();
                            }
                            catch(Ice.UserException ex)
                            {
                                throw new Ice.UnknownUserException(ex.ice_name(), ex);
                            }
                        }
                        og__.istr().skipEmptyEncaps();
                    }
                    catch(Ice.LocalException ex__)
                    {
                        throw new IceInternal.LocalExceptionWrapper(ex__, false);
                    }
                }
            }
            finally
            {
                handler__.reclaimOutgoing(og__);
            }
        }

        public void shutdown(_System.Collections.Generic.Dictionary<string, string> context__)
        {
            IceInternal.Outgoing og__ = handler__.getOutgoing("shutdown", Ice.OperationMode.Normal, context__);
            try
            {
                bool ok__ = og__.invoke();
                if(!og__.istr().isEmpty())
                {
                    try
                    {
                        if(!ok__)
                        {
                            try
                            {
                                og__.throwUserException();
                            }
                            catch(Ice.UserException ex)
                            {
                                throw new Ice.UnknownUserException(ex.ice_name(), ex);
                            }
                        }
                        og__.istr().skipEmptyEncaps();
                    }
                    catch(Ice.LocalException ex__)
                    {
                        throw new IceInternal.LocalExceptionWrapper(ex__, false);
                    }
                }
            }
            finally
            {
                handler__.reclaimOutgoing(og__);
            }
        }
    }
}

namespace Demo
{
    public sealed class HelloDelD_ : Ice.ObjectDelD_, HelloDel_
    {
        public void sayHello(int delay, _System.Collections.Generic.Dictionary<string, string> context__)
        {
            Ice.Current current__ = new Ice.Current();
            initCurrent__(ref current__, "sayHello", Ice.OperationMode.Normal, context__);
            IceInternal.Direct.RunDelegate run__ = delegate(Ice.Object obj__)
            {
                Hello servant__ = null;
                try
                {
                    servant__ = (Hello)obj__;
                }
                catch(_System.InvalidCastException)
                {
                    throw new Ice.OperationNotExistException(current__.id, current__.facet, current__.operation);
                }
                servant__.sayHello(delay, current__);
                return Ice.DispatchStatus.DispatchOK;
            };
            IceInternal.Direct direct__ = null;
            try
            {
                direct__ = new IceInternal.Direct(current__, run__);
                try
                {
                    Ice.DispatchStatus status__ = direct__.servant().collocDispatch__(direct__);
                    _System.Diagnostics.Debug.Assert(status__ == Ice.DispatchStatus.DispatchOK);
                }
                finally
                {
                    direct__.destroy();
                }
            }
            catch(Ice.SystemException)
            {
                throw;
            }
            catch(System.Exception ex__)
            {
                IceInternal.LocalExceptionWrapper.throwWrapper(ex__);
            }
        }

        public void shutdown(_System.Collections.Generic.Dictionary<string, string> context__)
        {
            Ice.Current current__ = new Ice.Current();
            initCurrent__(ref current__, "shutdown", Ice.OperationMode.Normal, context__);
            IceInternal.Direct.RunDelegate run__ = delegate(Ice.Object obj__)
            {
                Hello servant__ = null;
                try
                {
                    servant__ = (Hello)obj__;
                }
                catch(_System.InvalidCastException)
                {
                    throw new Ice.OperationNotExistException(current__.id, current__.facet, current__.operation);
                }
                servant__.shutdown(current__);
                return Ice.DispatchStatus.DispatchOK;
            };
            IceInternal.Direct direct__ = null;
            try
            {
                direct__ = new IceInternal.Direct(current__, run__);
                try
                {
                    Ice.DispatchStatus status__ = direct__.servant().collocDispatch__(direct__);
                    _System.Diagnostics.Debug.Assert(status__ == Ice.DispatchStatus.DispatchOK);
                }
                finally
                {
                    direct__.destroy();
                }
            }
            catch(Ice.SystemException)
            {
                throw;
            }
            catch(System.Exception ex__)
            {
                IceInternal.LocalExceptionWrapper.throwWrapper(ex__);
            }
        }
    }
}

namespace Demo
{
    public abstract class HelloDisp_ : Ice.ObjectImpl, Hello
    {
        #region Slice operations

        public void sayHello(int delay)
        {
            sayHello(delay, Ice.ObjectImpl.defaultCurrent);
        }

        public abstract void sayHello(int delay, Ice.Current current__);

        public void shutdown()
        {
            shutdown(Ice.ObjectImpl.defaultCurrent);
        }

        public abstract void shutdown(Ice.Current current__);

        #endregion

        #region Slice type-related members

        public static new string[] ids__ = 
        {
            "::Demo::Hello",
            "::Ice::Object"
        };

        public override bool ice_isA(string s)
        {
            return _System.Array.BinarySearch(ids__, s, IceUtilInternal.StringUtil.OrdinalStringComparer) >= 0;
        }

        public override bool ice_isA(string s, Ice.Current current__)
        {
            return _System.Array.BinarySearch(ids__, s, IceUtilInternal.StringUtil.OrdinalStringComparer) >= 0;
        }

        public override string[] ice_ids()
        {
            return ids__;
        }

        public override string[] ice_ids(Ice.Current current__)
        {
            return ids__;
        }

        public override string ice_id()
        {
            return ids__[0];
        }

        public override string ice_id(Ice.Current current__)
        {
            return ids__[0];
        }

        public static new string ice_staticId()
        {
            return ids__[0];
        }

        #endregion

        #region Operation dispatch

        public static Ice.DispatchStatus sayHello___(Hello obj__, IceInternal.Incoming inS__, Ice.Current current__)
        {
            checkMode__(Ice.OperationMode.Normal, current__.mode);
            IceInternal.BasicStream is__ = inS__.istr();
            is__.startReadEncaps();
            int delay;
            delay = is__.readInt();
            is__.endReadEncaps();
            obj__.sayHello(delay, current__);
            return Ice.DispatchStatus.DispatchOK;
        }

        public static Ice.DispatchStatus shutdown___(Hello obj__, IceInternal.Incoming inS__, Ice.Current current__)
        {
            checkMode__(Ice.OperationMode.Normal, current__.mode);
            inS__.istr().skipEmptyEncaps();
            obj__.shutdown(current__);
            return Ice.DispatchStatus.DispatchOK;
        }

        private static string[] all__ =
        {
            "ice_id",
            "ice_ids",
            "ice_isA",
            "ice_ping",
            "sayHello",
            "shutdown"
        };

        public override Ice.DispatchStatus dispatch__(IceInternal.Incoming inS__, Ice.Current current__)
        {
            int pos = _System.Array.BinarySearch(all__, current__.operation, IceUtilInternal.StringUtil.OrdinalStringComparer);
            if(pos < 0)
            {
                throw new Ice.OperationNotExistException(current__.id, current__.facet, current__.operation);
            }

            switch(pos)
            {
                case 0:
                {
                    return ice_id___(this, inS__, current__);
                }
                case 1:
                {
                    return ice_ids___(this, inS__, current__);
                }
                case 2:
                {
                    return ice_isA___(this, inS__, current__);
                }
                case 3:
                {
                    return ice_ping___(this, inS__, current__);
                }
                case 4:
                {
                    return sayHello___(this, inS__, current__);
                }
                case 5:
                {
                    return shutdown___(this, inS__, current__);
                }
            }

            _System.Diagnostics.Debug.Assert(false);
            throw new Ice.OperationNotExistException(current__.id, current__.facet, current__.operation);
        }

        #endregion

        #region Marshaling support

        public override void write__(IceInternal.BasicStream os__)
        {
            os__.writeTypeId(ice_staticId());
            os__.startWriteSlice();
            os__.endWriteSlice();
            base.write__(os__);
        }

        public override void read__(IceInternal.BasicStream is__, bool rid__)
        {
            if(rid__)
            {
                /* string myId = */ is__.readTypeId();
            }
            is__.startReadSlice();
            is__.endReadSlice();
            base.read__(is__, true);
        }

        public override void write__(Ice.OutputStream outS__)
        {
            Ice.MarshalException ex = new Ice.MarshalException();
            ex.reason = "type Demo::Hello was not generated with stream support";
            throw ex;
        }

        public override void read__(Ice.InputStream inS__, bool rid__)
        {
            Ice.MarshalException ex = new Ice.MarshalException();
            ex.reason = "type Demo::Hello was not generated with stream support";
            throw ex;
        }

        #endregion
    }
}

namespace Demo
{
    public abstract class AMI_Hello_sayHello : IceInternal.OutgoingAsync
    {
        public abstract void ice_response();

        public bool invoke__(Ice.ObjectPrx prx__, Demo.AMI_Hello_sayHello cb__, int delay, _System.Collections.Generic.Dictionary<string, string> ctx__)
        {
            acquireCallback__(prx__);
            try
            {
                prepare__(prx__, "sayHello", Ice.OperationMode.Normal, ctx__);
                os__.writeInt(delay);
                os__.endWriteEncaps();
                return send__();
            }
            catch(Ice.LocalException ex__)
            {
                releaseCallback__(ex__);
                return false;
            }
        }

        protected override void response__(bool ok__)
        {
            try
            {
                if(!ok__)
                {
                    try
                    {
                        throwUserException__();
                    }
                    catch(Ice.UserException ex__)
                    {
                        throw new Ice.UnknownUserException(ex__.ice_name(), ex__);
                    }return;
                }
                is__.skipEmptyEncaps();
            }
            catch(Ice.LocalException ex__)
            {
                finished__(ex__);
                return;
            }
            ice_response();
            releaseCallback__();
        }
    }

    public abstract class AMI_Hello_shutdown : IceInternal.OutgoingAsync
    {
        public abstract void ice_response();

        public bool invoke__(Ice.ObjectPrx prx__, Demo.AMI_Hello_shutdown cb__, _System.Collections.Generic.Dictionary<string, string> ctx__)
        {
            acquireCallback__(prx__);
            try
            {
                prepare__(prx__, "shutdown", Ice.OperationMode.Normal, ctx__);
                os__.endWriteEncaps();
                return send__();
            }
            catch(Ice.LocalException ex__)
            {
                releaseCallback__(ex__);
                return false;
            }
        }

        protected override void response__(bool ok__)
        {
            try
            {
                if(!ok__)
                {
                    try
                    {
                        throwUserException__();
                    }
                    catch(Ice.UserException ex__)
                    {
                        throw new Ice.UnknownUserException(ex__.ice_name(), ex__);
                    }return;
                }
                is__.skipEmptyEncaps();
            }
            catch(Ice.LocalException ex__)
            {
                finished__(ex__);
                return;
            }
            ice_response();
            releaseCallback__();
        }
    }
}
